import { useEffect, useRef, useState } from 'react';
export function useRafDebouncedValue(value) {
    var _a = useState(value), debouncedState = _a[0], setDebouncedState = _a[1];
    var queued = useRef();
    useEffect(function () {
        queued.current = requestAnimationFrame(function () { return setDebouncedState(value); });
        return function () {
            queued.current && cancelAnimationFrame(queued.current);
        };
    }, [value, setDebouncedState]);
    useEffect(function () {
        return function () {
            queued.current && cancelAnimationFrame(queued.current);
        };
    }, []);
    return [debouncedState];
}
//# sourceMappingURL=useRafDebouncedValue.js.map